#
# Sensus Consulting Ltd, Copyright 1997-1998
#
# Matt Newman <matt@sensus.org>
#
#
# file://		- returns list of volumes
#
namespace eval url {}
namespace eval url::file {}

proc url::file {option args} {
	variable file::methods
	if [info exists methods($option)] {
		return [uplevel 1 url::file::$option $args]
	}
	return [uplevel 1 file $option $args]
}
namespace eval url::file {
	variable cache
	variable methods
	set methods(configure)		1
	set methods(children)		1
	set methods(iscontainer)	1
	set methods(parent)			1
	set methods(tail)			1

	proc icon {path {icon ""}} {
		variable icons
		set path	[string tolower $path]
		if {$icon == ""} {
			if [info exists icons($path)] {
				return $icons($path)
			}
			return ""
		} else {
			set icons($path)	$icon
		}	
	}
	icon default	[img document]
	icon root		[img mycomputer]
	icon folder		[img folder]
	icon floppy		[img floppy]
	icon drive		[img drive]
	icon recycle	[img recycle]
	icon a:/ $icons(floppy)
	icon b:/ $icons(floppy)
	foreach dl [::split cdefghijklmnopqrstuvwxyz ""] {
		icon ${dl}:/ $icons(drive)
		icon ${dl}:/recycler $icons(recycle)
		icon ${dl}:/recycled $icons(recycle)
	}
}
;proc url::file::iscontainer {path} {
	return [file isdirectory $path]
}
;proc url::file::configure {path} {
	variable icons

	if {$path == ""} {
		return [list -name "My Computer" \
				-container 1 -image $icons(root) \
				-size 0 -mtime 0 -type file]
	} elseif {$path == "a:/"} {
		# Avoids the anoying Abort, Retry, Ignore if
		# You don't have a floppy in the drive.
		return [list -name $path \
				-container 1 -image [icon $path] \
				-size 0 -mtime 0 -type volume]
	}
	set tail [file tail $path]
	if {$tail == ""} {
		set tail $path
	}
	file lstat $path sb
	set icon	[icon $path]
	set ret [list -name $tail -size $sb(size) -mtime $sb(mtime) -type file]
	if [string compare $sb(type) directory]==0 {
		lappend ret -container 1
		if {$icon == ""} {
			lappend ret -image $icons(folder)
		} else {
			lappend ret -image $icon
		}
	} else {
		lappend ret -container 0
		if {$icon == ""} {
			lappend ret -image $icons(default)
		} else {
			lappend ret -image $icon
		}
	}
 	return $ret
}
;proc url::file::children {path {glob *}} {
	variable cache
	if [info exists cache($path)] {
		return $cache($path)
	}
	if {$path == ""} {
		#return [set cache($path) "a:/ c:/"]
		return [set cache($path) [file volumes]]
	}
	set ret	{}
	set cwd	[pwd]
	catch {
		cd $path
		set ret [glob -nocomplain $glob]
	}
	cd $cwd
	return [lsort $ret]
}
;proc url::file::parent {path} {
	return [file root $path]
}
;proc url::file::tail {path} {
	if [regexp {^//[^/]*/[^/]*$} $path] {
		regsub {^.*/} $path {} path
		return $path
	} else {
		return [_file tail $path]
	}
}
